MODULE trclsm
   !!=======================================================================================
   !!
   !!                       *** MODULE trclsm ****
   !!
   !!  READS specific NAMELIST for sms terms
   !!
   !!=======================================================================================
      !!----------------------------------------------------------------------
      !! * Modules used
      !! ==============
      USE oce_trc
      USE trc
      USE sms

                                                                                                                      
      IMPLICIT NONE                             
      PRIVATE

  !! * Accessibility
   PUBLIC trc_lsm

CONTAINS

#if defined key_passivetrc

SUBROUTINE trc_lsm
!!---------------------------------------------------------------------
!!
!!                       ROUTINE trclsm
!!                     ******************
!!  PURPOSE :
!!  ---------
!!     READS specific NAMELIST for sms terms 
!!
!!   History:
!!   --------
!!      original  : 99-10 (M.A. Foujols, M. Levy) passive tracer
!!                  00-04 (O. Aumont, M.A. Foujols) HAMOCC3 and P3ZD
!!                  02-05 (O. Aumont) AGE TRACER
!!     03/2005  O. Aumont and A. El Moussaoui  F90
!!----------------------------------------------------------------------

#    if defined key_trc_npzd
#    include "trclsm.npzd.h90"
#    elif defined key_trc_lobster1
#    include "trclsm.lobster1.h90"
#    elif defined key_trc_hamocc3
#    include "trclsm.hamocc3.h90"
#    elif defined key_trc_age
#    include "trclsm.age.h90"
#    elif defined key_trc_pisces
#    include "trclsm.pisces.h90"
#    else
!!      user can define here his own sms namelist
#    endif

END  SUBROUTINE  trc_lsm

#else

SUBROUTINE trc_lsm
!!================
   !! no passive tracers
END  SUBROUTINE  trc_lsm

#endif  

END MODULE trclsm  
